/*
 *  status_LED.h
 *
 *  Created on: 07.07.2024
 *      Author: Hamza
 */
 
#ifndef INC_STATUS_LED_H
#define INC_STATUS_LED_H

#include "stm32f3xx_hal.h"
#include <state_machine.h>

typedef enum {
  OFF,
  RED,
  GREEN,
  BLUE,
  YELLOW,
  PINK,
  CYAN,
  WHITE
} color;

void status_led_init(TIM_HandleTypeDef* r, TIM_HandleTypeDef* g, TIM_HandleTypeDef* b);
void status_led_update();

void status_led_blink_sequence(uint8_t blinks, color color);
void status_led_set_color(color color);
void status_led_set(uint8_t r, uint8_t g, uint8_t b);

#endif /* "INC_STATUS_LED_H" */